UNIT mTRechteck;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses ExtCtrls, Graphics, mTPunkt, mTEckenobjekt;

type
  TRechteck = class(TEckenobjekt)

  private //Attribute
    Eckpunkt1 : TPunkt;
    Eckpunkt2 : TPunkt;

     //Objektbeziehungen:
        // hatTPunkt1, // hatTPunkt2 : TPunkt;

  public //Methoden
    constructor create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor; FF: TColor); virtual;
    procedure SetzeEckpunkt1 (pEckpunkt1: TPunkt); virtual;
    procedure SetzeEckpunkt2 (pEckpunkt2: TPunkt); virtual;
    procedure Zeichnen (PB: TPaintbox); override;
    function GibEckpunkt1 : TPunkt; virtual;
    function GibEckpunkt2 : TPunkt; virtual;
    destructor destroy; override;
    procedure Markiere(PB: TPaintbox); override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteck: Methodendefinition 
//+---------------------------------------------------------------------

//-------- create (public) ---------------------------------------------
constructor TRechteck.create (x1: integer; y1: integer; x2: integer; y2: integer; LF: TColor; FF: TColor);
begin
  inherited create(LF,FF);
  Eckpunkt1:= TPunkt.create(x1,y1,LF);
  Eckpunkt2:= TPunkt.create(x2,y2,LF);
end;

//-------- SetzeEckpunkt1 (public) -------------------------------------
procedure TRechteck.SetzeEckpunkt1 (pEckpunkt1: TPunkt);
begin
  Eckpunkt1 := pEckpunkt1
end;

//-------- SetzeEckpunkt2 (public) -------------------------------------
procedure TRechteck.SetzeEckpunkt2 (pEckpunkt2: TPunkt);
begin
  Eckpunkt2 := pEckpunkt2
end;

//-------- Zeichnen (public) -------------------------------------------
procedure TRechteck.Zeichnen (PB: TPaintbox);
begin
  inherited Zeichnen(PB);
  PB.Canvas.Rectangle(Eckpunkt1.GibX,Eckpunkt1.GibY,Eckpunkt2.GibX,Eckpunkt2.Giby);
end;

//-------- GibEckpunkt1 (public) ---------------------------------------
function TRechteck.GibEckpunkt1 : TPunkt;
begin
  result  := Eckpunkt1
end;

//-------- GibEckpunkt2 (public) ---------------------------------------
function TRechteck.GibEckpunkt2 : TPunkt;
begin
  result  := Eckpunkt2
end;

//-------- destroy (public) --------------------------------------------
destructor TRechteck.destroy;
begin
  Eckpunkt1.free;
  Eckpunkt2.free;
  inherited destroy;
end;

//-------- Markiere (public) -----------------------------------------
procedure TRechteck.Markiere(pb: TPaintbox);
begin
  inherited Markiere(PB);
  pb.Canvas.Rectangle(GibEckpunkt1.GibX-4,GibEckpunkt1.GibY-4,GibEckpunkt1.GibX+4,GibEckpunkt1.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt2.GibX-4,GibEckpunkt2.GibY-4,GibEckpunkt2.GibX+4,GibEckpunkt2.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt1.GibX-4,GibEckpunkt2.GibY-4,GibEckpunkt1.GibX+4,GibEckpunkt2.GibY+4);
  pb.Canvas.Rectangle(GibEckpunkt2.GibX-4,GibEckpunkt1.GibY-4,GibEckpunkt2.GibX+4,GibEckpunkt1.GibY+4);
end;


end.
